<template>
  <div class="mt-[20px]">
    <main
      v-loading="isLoading"
      class="py-0 px-4 ml-0 relative my-0 mx-auto max-w-full w-full"
    >
      <div class="mt-4 mb-6 relative flex justify-between flex-wrap">
        <div class="flex-wrap justify-between flex w-full mt-3">
          <div class="w-full mb-4 relative h-[40px]">
            <div
              class="box-shadow-inset flex items-center bg-[var(--button-bg)] rounded-lg"
              @click="openGameSearchModal"
            >
              <div class="icon-search flex items-center">
                <font-awesome-icon icon="magnifying-glass" class="pl-3" />
                <span
                  class="visible indent-0 opacity-100 text-[var(--font-color-primary)] text-sm pl-4"
                >
                  {{ $t("Search All Games") }}...
                </span>
              </div>
            </div>
          </div>
          <div
            class="w-full ml-0 flex items-center h-[40px] text-sm py-0 px-4 bg-[var(--button-bg)] border-[var(--element-border-color)] border-[1px] box-shadow rounded-lg"
            @click="dialogVisible = true"
          >
            {{ $t("select_provider") }}
            <font-awesome-icon icon="arrow-right" class="pl-3" />
          </div>
        </div>
      </div>
      <div class="flex flex-col">
        <h1
          class="text-2xl w-auto m-0 font-bold text-[var(--title-font-color)] block"
        >
          {{ $t("games") }}
        </h1>
        <game-type-button />
      </div>
      <game-entry-card :games="splitGames" />
      <no-data
        v-if="isProcessingGames || !splitGames?.length"
        :empty-text="
          isProcessingGames ? $t('searching_game') : $t('no_game_found')
        "
      />
      <div
        v-if="index + 1 < splitedGames.length && !isProcessingGames"
        class="mb-[10px] w-full flex flex-col"
        @click="seeMore"
      >
        <div class="flex h-10">
          <div class="more-btn flex items-center justify-center rounded-md">
            <span
              class="text-center uppercase text-sm font-semibold text-[#fff]"
              >{{ $t("more") }}</span
            >
          </div>
        </div>
      </div>
    </main>
    <provider-dialog
      v-model:dialogVisible="dialogVisible"
      :providers="providers"
    />
  </div>
  <search-modal :is-open="isGameSearchOpen" @close="closeGameSearchModal" />
</template>

<script lang="ts">
import { defineComponent, ref, watch, computed } from "vue";
import { useRoute, useRouter } from "vue-router";
import { Search } from "@element-plus/icons-vue";
import GameTypeButton from "./game-type-button.client.vue";
import ProviderDialog from "./provider-dialog.client.vue";
import GameEntryCard from "./game-entry-card.client.vue";
import NoData from "./no-data.client.vue";
import SearchModal from "./search-modal.client.vue";
import { IGameBsi } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import {
  handleGameEntryOpenWindow,
  useGameEntryComponent,
} from "@/composables/useTheme";
import { IGame } from "@/models/IGetPlayableGamesResponse";

export default defineComponent({
  name: "MGameEntryComponent",
  components: {
    GameTypeButton,
    ProviderDialog,
    GameEntryCard,
    NoData,
    SearchModal,
  },
  setup() {
    const { getAssetImage } = commonHelper;
    const route = useRoute();
    const router = useRouter();
    const providerModel = ref<string>();
    const dialogVisible = ref(false);
    const {
      filtered,
      isLoading,
      headerTab,
      gameTypes,
      providers,
      initialGameEntry,
      authenticated,
      getGameEntryFiltered,
      handleSelectedTabOption,
    } = useGameEntryComponent();

    const games = computed(() => initialGameEntry.value);
    const splitGames = ref<Array<IGameBsi> | undefined>([]);
    const splitedGames = ref<any>([]);
    const index = ref(0);
    const isProcessingGames = ref(false);
    const getFirstTwentyFourGames = () => {
      splitGames.value = [];
      splitGames.value = initialGameEntry.value?.slice(0, 24);
    };
    const seeMore = () => {
      index.value += 1;
      splitedGames.value[index.value].forEach((item: any) => {
        splitGames.value?.push(item);
      });
    };
    const splitGame = () => {
      splitedGames.value = [];
      const chunkSize = 24;
      if (games.value !== undefined) {
        for (let i = 0; i < games.value.length; i += chunkSize) {
          const chunk: Array<IGameBsi> | undefined =
            initialGameEntry.value?.slice(i, i + chunkSize);
          splitedGames.value.push(chunk);
        }
      }
    };

    const handleGameClicked = (game: IGame) => {
      if (authenticated) {
        handleGameEntryOpenWindow(game, 550, 850);
      } else {
        router.push("/login");
      }
    };
    const handleProviderClicked = (path: string) => {
      dialogVisible.value = false;
      router.push(`/games/${path}__n__gt`);
    };

    const checkIsGameType = (params: string) =>
      gameTypes.value.includes(params);
    async function checkGameType() {
      isProcessingGames.value = true;
      splitGames.value = [];
      const game = {
        Type: String(filtered.value.slice(0, -7)),
        Value: String(filtered.value.slice(0, -7)),
      };
      if (filtered.value === "") {
        await getGameEntryFiltered(game);
        getFirstTwentyFourGames();
        splitGame();
      } else {
        const isGameType = checkIsGameType(game.Value);
        if (game.Value === "HotGames" || game.Value === "NewGames" || game.Value === "Favorite") {
          await getGameEntryFiltered(game);
          getFirstTwentyFourGames();
          splitGame();
        } else {
          game.Type = isGameType ? "GameType" : "provider";
          await getGameEntryFiltered(game);
          getFirstTwentyFourGames();
          splitGame();
        }
      }
      isProcessingGames.value = false;
    }
    checkGameType();
    watch(
      () => route.params.filter,
      () => {
        if (route.params.filter !== undefined) {
          filtered.value = route.params.filter;
          checkGameType();
        }
      }
    );

    const isGameSearchOpen = ref(false);
    const openGameSearchModal = () => {
      isGameSearchOpen.value = true;
    };
    const closeGameSearchModal = () => {
      isGameSearchOpen.value = false;
    };

    return {
      filtered,
      isLoading,
      headerTab,
      gameTypes,
      providers,
      initialGameEntry,
      providerModel,
      authenticated,
      handleSelectedTabOption,
      handleGameEntryOpenWindow,
      handleGameClicked,
      Search,
      dialogVisible,
      getAssetImage,
      handleProviderClicked,
      splitGame,
      splitGames,
      splitedGames,
      seeMore,
      index,
      isProcessingGames,
      isGameSearchOpen,
      closeGameSearchModal,
      openGameSearchModal,
    };
  },
});
</script>

<style lang="scss" scoped>
.flex.px-4 {
  padding-left: 0.5rem;
  padding-right: 0.5rem;
}
.more-btn {
  width: 100%;
  max-width: 100%;
  box-shadow: var(--box-shadow);
  text-transform: uppercase;
  box-sizing: border-box;
  color: #fff;
  background: var(--accent-gradient);
  border: 2px solid var(--element-border-color);
}
.icon-search {
  // width: 40px;
  height: 40px;
  font-size: 16px;
  -ms-flex-negative: 0;
  flex-shrink: 0;
  color: var(--font-color-primary);
}
.game-container {
  @apply grid grid-cols-2 gap-[3vw] py-[3vw] px-[4vw] my-[12.8vw];
}

.search-field {
  @apply bg-white py-[1vw] px-[4vw] w-full;

  :deep(.el-input) {
    @apply flex items-center justify-center mr-4;
    .el-input__inner {
      --el-input-border-color: transparent;
      --el-input-hover-border-color: transparent;
      @apply h-full text-[4vw];

      &:hover {
        box-shadow: 0 0 0 1px transparent inset;
      }
    }
  }
}
</style>
